CON
	__MBOX_SIZE = 7
	__STACK_SIZE = 1
	Txpin = 30
VAR
  long __mbox[__MBOX_SIZE]
  long __objmem[9]
  long __stack[__STACK_SIZE]
  byte __cognum

PUB __cognew | id
  if (__cognum == 0)
    longfill(@__mbox, 0, __MBOX_SIZE)
    __mbox[0] := @__objmem
    __mbox[1] := @__stack
    id := cognew(@entry, @__mbox)
    __cognum := id + 1
  return id

PUB __cogstop
  if __cognum
    __lock  ' wait until everyone else is finished
    cogstop(__cognum~ - 1)
    __mbox[0] := 0
    __cognum := 0
PRI __lock
  repeat
    repeat until __mbox[0] == 0
    __mbox[0] := __cognum
  until __mbox[0] == __cognum

  repeat until __mbox[1] == 0
PRI __unlock
  __mbox[0] := 0

PRI __invoke(func, getresult) : r
  __mbox[1] := func - @entry
  if getresult
    repeat until __mbox[1] == 0
    r := __mbox[2]
  __unlock
  return r

PUB Start(Baudrate)
  __lock
  __mbox[2] := Baudrate
  return __invoke(@pasm_Start, 1)

PUB Tx(C)
  __lock
  __mbox[2] := C
  return __invoke(@pasm_Tx, 0)

PUB Str(S)
  __lock
  __mbox[2] := S
  return __invoke(@pasm_Str, 0)

PUB Num(Val, Base, Signflag, Digitsneeded)
  __lock
  __mbox[2] := Val
  __mbox[3] := Base
  __mbox[4] := Signflag
  __mbox[5] := Digitsneeded
  return __invoke(@pasm_Num, 0)

PUB Dec(Val)
  __lock
  __mbox[2] := Val
  return __invoke(@pasm_Dec, 0)

PUB Decuns(Val, Digits)
  __lock
  __mbox[2] := Val
  __mbox[3] := Digits
  return __invoke(@pasm_Decuns, 0)

PUB Hex(Val, Digits)
  __lock
  __mbox[2] := Val
  __mbox[3] := Digits
  return __invoke(@pasm_Hex, 0)

PUB Nl
  __lock
  return __invoke(@pasm_Nl, 0)

DAT
	org	0
entry
	mov	mboxptr, par
	mov	arg1, #0
	rdlong	objptr, mboxptr
	wrlong	arg1, mboxptr
	add	mboxptr, #4
	rdlong	sp, mboxptr
	wrlong	arg1, mboxptr
waitloop
	rdlong	mboxcmd, mboxptr wz
 if_e	jmp	#waitloop
	add	mboxptr, #4
	rdlong	arg1, mboxptr
	add	mboxptr, #4
	rdlong	arg2, mboxptr
	add	mboxptr, #4
	rdlong	arg3, mboxptr
	add	mboxptr, #4
	rdlong	arg4, mboxptr
	sub	mboxptr, #12
	shr	mboxcmd, #2
	jmp	mboxcmd
doreturn
	wrlong	result1, mboxptr
	sub	mboxptr, #4
	mov	arg1, #0
	wrlong	arg1, mboxptr
	jmp	#waitloop

pasm_Start
	movs	_Start_ret, #doreturn
_Start
	rdlong	muldiva_, #0
	mov	muldivb_, arg1
	call	#divide_
	wrlong	muldivb_, objptr
	mov	result1, #1
_Start_ret
	ret

pasm_Tx
	movs	_Tx_ret, #doreturn
_Tx
	mov	_Tx__mask_0001, imm_1073741824_
	or	OUTA, imm_1073741824_
	or	DIRA, imm_1073741824_
	or	arg1, #256
	shl	arg1, #1
	mov	_Tx_Val, arg1
	mov	_Tx_Nextcnt, CNT
	mov	_Tx__idx__0002, #10
L__0021
	rdlong	Tx_tmp002_, objptr
	add	_Tx_Nextcnt, Tx_tmp002_
	mov	arg1, _Tx_Nextcnt
	waitcnt	arg1, #0
	shr	_Tx_Val, #1 wc
	muxc	OUTA, _Tx__mask_0001
	djnz	_Tx__idx__0002, #L__0021
_Tx_ret
	ret

pasm_Str
	movs	_Str_ret, #doreturn
_Str
	mov	_Str_S, arg1
L__0026
	mov	Str_tmp001_, _Str_S
	add	_Str_S, #1
	rdbyte	_Str_C, Str_tmp001_ wz
 if_e	jmp	#L__0027
	mov	arg1, _Str_C
	call	#_Tx
	jmp	#L__0026
L__0027
_Str_ret
	ret

pasm_Num
	movs	_Num_ret, #doreturn
_Num
	mov	_Num_Val, arg1
	mov	_Num_Base, arg2
	mov	_Num_Signflag, arg3 wz
	mov	_Num_Digitsneeded, arg4
 if_e	jmp	#L__0028
	cmps	_Num_Val, #0 wc,wz
 if_b	mov	_Num_Signflag, #45
 if_b	neg	_Num_Val, _Num_Val
L__0028
	cmps	_Num_Digitsneeded, #32 wc,wz
 if_a	mov	_Num_Digitsneeded, #32
	mov	_Num_I, #0
L__0031
	cmps	_Num_Val, #0 wc,wz
 if_ae	jmp	#L__0034
	mov	_Num__cse__0008, _Num_Val
	and	_Num__cse__0008, #1
	mov	_Num_R1, _Num__cse__0008
	shr	_Num_Val, #1
	mov	_Num__cse__0009, _Num_Val
	mov	_Num_Q1, _Num__cse__0009
	mov	muldiva_, _Num_Q1
	mov	muldivb_, _Num_Base
	call	#divide_
	mov	_Num__cse__0010, muldiva_
	mov	_Num__cse__0011, _Num__cse__0010
	shl	_Num__cse__0011, #1
	mov	_Num__cse__0012, _Num_R1
	add	_Num__cse__0012, _Num__cse__0011
	mov	_Num_Digit, _Num__cse__0012
	mov	muldiva_, _Num_Q1
	mov	muldivb_, _Num_Base
	call	#divide_
	mov	_Num__cse__0013, muldivb_
	mov	_Num__cse__0014, _Num__cse__0013
	shl	_Num__cse__0014, #1
	mov	_Num_Val, _Num__cse__0014
	cmps	_Num_Digit, _Num_Base wc,wz
 if_ae	add	_Num_Val, #1
 if_ae	sub	_Num_Digit, _Num_Base
 if_ae	mov	_Num__cse__0015, _Num_Digit
	jmp	#L__0036
L__0034
	mov	muldiva_, _Num_Val
	mov	muldivb_, _Num_Base
	call	#divide_
	mov	_Num__cse__0016, muldiva_
	mov	_Num_Digit, _Num__cse__0016
	mov	muldiva_, _Num_Val
	mov	muldivb_, _Num_Base
	call	#divide_
	mov	_Num__cse__0017, muldivb_
	mov	_Num_Val, _Num__cse__0017
L__0036
	cmps	_Num_Digit, #0 wc,wz
 if_b	jmp	#L__0037
	cmps	_Num_Digit, #9 wc,wz
 if_be	add	_Num_Digit, #48
 if_be	mov	_Num__cse__0018, _Num_Digit
 if_be	jmp	#L__0038
L__0037
	sub	_Num_Digit, #10
	mov	_Num__cse__0019, _Num_Digit
	mov	_Num__cse__0020, _Num__cse__0019
	add	_Num__cse__0020, #65
	mov	_Num_Digit, _Num__cse__0020
L__0038
	mov	Num_tmp004_, _Num_I
	add	_Num_I, #1
	add	objptr, #4
	mov	Num_tmp003_, objptr
	sub	objptr, #4
	add	Num_tmp003_, Num_tmp004_
	wrbyte	_Num_Digit, Num_tmp003_
	sub	_Num_Digitsneeded, #1
	cmps	_Num_Val, #0 wz
 if_ne	jmp	#L__0040
	cmps	_Num_Digitsneeded, #0 wc,wz
 if_be	jmp	#L__0039
L__0040
	cmps	_Num_I, #32 wc,wz
 if_b	jmp	#L__0031
L__0039
	cmps	_Num_Signflag, #1 wc,wz
 if_be	jmp	#L__0041
	mov	arg1, _Num_Signflag
	call	#_Tx
L__0041
L__0042
	cmps	_Num_I, #0 wc,wz
 if_be	jmp	#L__0043
	sub	_Num_I, #1
	add	objptr, #4
	mov	Num_tmp002_, objptr
	sub	objptr, #4
	add	Num_tmp002_, _Num_I
	rdbyte	arg1, Num_tmp002_
	call	#_Tx
	jmp	#L__0042
L__0043
_Num_ret
	ret

pasm_Dec
	movs	_Dec_ret, #doreturn
_Dec
	mov	arg2, #10
	mov	arg3, #1
	mov	arg4, #0
	call	#_Num
_Dec_ret
	ret

pasm_Decuns
	movs	_Decuns_ret, #doreturn
_Decuns
	mov	arg4, arg2
	mov	arg2, #10
	mov	arg3, #0
	call	#_Num
_Decuns_ret
	ret

pasm_Hex
	movs	_Hex_ret, #doreturn
_Hex
	mov	arg4, arg2
	mov	arg2, #16
	mov	arg3, #0
	call	#_Num
_Hex_ret
	ret

pasm_Nl
	movs	_Nl_ret, #doreturn
_Nl
	mov	arg1, #13
	call	#_Tx
	mov	arg1, #10
	call	#_Tx
_Nl_ret
	ret
' code originally from spin interpreter, modified slightly

divide_
       abs     muldiva_,muldiva_     wc       'abs(x)
       muxc    itmp2_,#%11                    'store sign of x
       abs     muldivb_,muldivb_     wc,wz    'abs(y)
 if_c  xor     itmp2_,#%10                    'store sign of y
        mov     itmp1_,#0                    'unsigned divide
        mov     DIVCNT,#32
mdiv__
        shr     muldivb_,#1        wc,wz
        rcr     itmp1_,#1
 if_nz   djnz    DIVCNT,#mdiv__
mdiv2__
        cmpsub  muldiva_,itmp1_        wc
        rcl     muldivb_,#1
        shr     itmp1_,#1
        djnz    DIVCNT,#mdiv2__
        test    itmp2_,#1        wc       'restore sign, remainder
        negc    muldiva_,muldiva_ 
        test    itmp2_,#%10      wc       'restore sign, division result
        negc    muldivb_,muldivb_
divide__ret
	ret
DIVCNT
	long	0

imm_1073741824_
	long	1073741824
itmp1_
	long	0
itmp2_
	long	0
mboxcmd
	long	0
mboxptr
	long	0
objptr
	long	0
result1
	long	0
sp
	long	0
COG_BSS_START
	fit	496
	org	COG_BSS_START
Num_tmp002_
	res	1
Num_tmp003_
	res	1
Num_tmp004_
	res	1
Str_tmp001_
	res	1
Tx_tmp002_
	res	1
_Num_Base
	res	1
_Num_Digit
	res	1
_Num_Digitsneeded
	res	1
_Num_I
	res	1
_Num_Q1
	res	1
_Num_R1
	res	1
_Num_Signflag
	res	1
_Num_Val
	res	1
_Num__cse__0008
	res	1
_Num__cse__0009
	res	1
_Num__cse__0010
	res	1
_Num__cse__0011
	res	1
_Num__cse__0012
	res	1
_Num__cse__0013
	res	1
_Num__cse__0014
	res	1
_Num__cse__0015
	res	1
_Num__cse__0016
	res	1
_Num__cse__0017
	res	1
_Num__cse__0018
	res	1
_Num__cse__0019
	res	1
_Num__cse__0020
	res	1
_Str_C
	res	1
_Str_S
	res	1
_Tx_Nextcnt
	res	1
_Tx_Val
	res	1
_Tx__idx__0002
	res	1
_Tx__mask_0001
	res	1
arg1
	res	1
arg2
	res	1
arg3
	res	1
arg4
	res	1
muldiva_
	res	1
muldivb_
	res	1
	fit	496
